package miolnet.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

@Entity
@Table(name = "Gathers")
public class Gather implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	@GeneratedValue
	@Column(name = "GatherID")
	private int id;
	
	@NotNull
	@Column(name = "Gathertime", nullable = false, updatable = false)
	private Date gatherTime;
	
	public Gather() {
	}

	public Gather(Date gatherTime) {
		super();
		this.gatherTime = gatherTime;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Date getGatherTime() {
		return gatherTime;
	}

	public void setGatherTime(Date gatherTime) {
		this.gatherTime = gatherTime;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Gather other = (Gather) obj;
		return id == other.id;
	}

	@Override
	public String toString() {
		return "Gather [id=" + id + ", gatherTime=" + gatherTime + "]";
	}

}
