package miolnet.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import miolnet.guconnectivity.Protocol;

@Entity
@Table(name = "Logindetails")
public class LoginDetails implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	@Column(name = "LogindetailsID")
	private int id;
	
	@NotNull
	@Size(max = 40)
	@Column(name = "Username", nullable = false)
	private String username;
	
	@NotNull
	@Size(max = 32)
	@Column(name = "Password", nullable = false)
	private String password;
	
	@NotNull
	@Enumerated(EnumType.STRING)
	@Column(name = "Protocol", nullable = false)
	private Protocol protocol;
	
	public LoginDetails() {
	}

	public LoginDetails(String username, String password, Protocol protocol) {
		super();
		this.username = username;
		this.password = password;
		this.protocol = protocol;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public Protocol getProtocol() {
		return protocol;
	}

	public void setProtocol(Protocol protocol) {
		this.protocol = protocol;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		LoginDetails other = (LoginDetails) obj;
		return id == other.id;
	}

	@Override
	public String toString() {
		return "LoginDetails [id=" + id + ", username=" + username + ", protocol=" + protocol + "]";
	}
	
}
