package miolnet.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name = "Modulesensors")
public class ModuleSensor implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	@Column(name = "ModulesensorID")
	private int id;
	
	@Column(name = "Priority")
	private int priority;
	
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "SensorID", nullable = false)
	private Sensor sensor;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ModuleID", nullable = false)
	private Module module;
	
	public ModuleSensor() {
	}
	
	public ModuleSensor(final Sensor sensor, final Module module, int priority) {
		this.sensor = sensor;
		this.module = module;
		this.priority = priority;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getPriority() {
		return priority;
	}

	public void setPriority(int priority) {
		this.priority = priority;
	}

	public Sensor getSensor() {
		return sensor;
	}

	public void setSensor(Sensor sensor) {
		this.sensor = sensor;
	}

	public Module getModule() {
		return module;
	}

	public void setModule(Module module) {
		this.module = module;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ModuleSensor other = (ModuleSensor) obj;
		return id == other.id;
	}

	@Override
	public String toString() {
		return "ModuleSensor [id=" + id + ", priority=" + priority + ", sensor=" + sensor + ", module=" + module + "]";
	}
	
}
