package miolnet.services;

import java.util.List;

import javax.ejb.Local;

import miolnet.model.Module;

/**
 * 
 * @author Olmr Miloš
 *
 */
@Local
public interface ModuleServiceLocal {
	
	/**
	 * 
	 * @param module
	 * @return
	 */
	Module createModule(final Module module);
	
	/**
	 * 
	 * @param name
	 * @param tag
	 * @param author
	 * @param version
	 * @return
	 */
	Module createModule(final String name, final String tag, final String author, final String version);
	
	/**
	 * 
	 * @param module
	 * @return
	 */
	Module updateModule(final Module module);
	
	/**
	 * 
	 * @param module
	 * @return
	 */
	Module removeModule(final Module module);
	
	/**
	 * 
	 * @return
	 */
	List<Module> getAll();
	
	/**
	 * 
	 * @param id
	 * @return
	 */
	Module getById(int id);
	
	/**
	 * 
	 * @param tag
	 * @return
	 */
	Module getByTag(String tag);
	
}
