package miolnet.services;

import java.util.Date;
import java.util.List;

import javax.ejb.Local;

import miolnet.model.Module;
import miolnet.model.Record;
import miolnet.model.User;

/**
 * 
 * @author Olmr Miloš
 *
 */
@Local
public interface RecordServiceLocal {

	/**
	 * 
	 * @param record
	 * @return
	 */
	Record createRecord(Record record);
	
	/**
	 * 
	 * @param recordTime
	 * @param value
	 * @param status
	 * @return
	 */
	Record createRecord(Date recordTime, String value, boolean status);
	
	/**
	 * 
	 * @param recordTime
	 * @param value
	 * @param status
	 * @param user
	 * @return
	 */
	Record createRecord(Date recordTime, String value, boolean status, User user);
	
	/**
	 * 
	 * @param recordTime
	 * @param value
	 * @param status
	 * @param module
	 * @return
	 */
	Record createRecord(Date recordTime, String value, boolean status, Module module);
	
	/**
	 * 
	 * @param needle
	 * @param n
	 * @return
	 */
	List<Record> getLastNRecordsWithValue(String needle, int n);
	
	/**
	 * 
	 * @param user
	 * @param needle
	 * @param n
	 * @return
	 */
	List<Record> getLastNRecordsWithValue(User user, String needle, int n);
	
	/**
	 * 
	 * @param module
	 * @param needle
	 * @param n
	 * @return
	 */
	List<Record> getLastNRecordsWithValue(Module module, String needle, int n);
	
	/**
	 * 
	 * @param needle
	 * @param start
	 * @param end
	 * @return
	 */
	List<Record> getRecordsWithValueInDateInterval(String needle, Date start, Date end);
	
	/**
	 * 
	 * @param user
	 * @param needle
	 * @param start
	 * @param end
	 * @return
	 */
	List<Record> getRecordsWithValueInDateInterval(User user, String needle, Date start, Date end);
	
	/**
	 * 
	 * @param module
	 * @param needle
	 * @param start
	 * @param end
	 * @return
	 */
	List<Record> getRecordsWithValueInDateInterval(Module module, String needle, Date start, Date end);
	
}
