package miolnet.services;

import java.util.List;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.TypedQuery;

import miolnet.model.Role;

/**
 * Session Bean implementation class RoleService
 */
@Stateless
public class RoleService implements RoleServiceLocal {

	@Inject
	private EntityManager em;
	
    /**
     * Default constructor. 
     */
    public RoleService() {
        // TODO Auto-generated constructor stub
    }

	@Override
	public Role getByName(final String name) {
		final TypedQuery<Role> query = em.createNamedQuery("findRoleByName", Role.class);
		query.setParameter("name", name);
		try {
			return query.getSingleResult();
		} catch(NoResultException e) {
		}
		return null;
	}

	@Override
	public Role getById(int id) {
		return em.find(Role.class, id);
	}

	@Override
	public List<Role> getAll() {
		final TypedQuery<Role> query = em.createNamedQuery("findAllRoles", Role.class);
		return query.getResultList();
	}

}
