package miolnet.services;

import java.util.Date;
import java.util.List;

import javax.ejb.Local;

import miolnet.model.Gather;
import miolnet.model.Sensor;
import miolnet.model.Temperature;

@Local
public interface TemperatureServiceLocal {

	Temperature addTemperature(Temperature temp);
	
	Temperature addTemperature(float temp, Sensor sensor, Gather gather);
	
	Temperature getCurrentTemperature(Sensor sensor);
	
	Temperature getPreviousTemperature(Sensor sensor);
	
	List<Temperature> getDayTemperatures(Sensor sensor);
	
	List<Temperature> getWeekTemperatures(Sensor sensor);
	
	List<Temperature> getMonthTemperatures(Sensor sensor);
	
	List<Temperature> getYearTemperatures(Sensor sensor);
	
	List<Temperature> getCustomIntervalTemperatures(Sensor sensor, Date from, Date to);
	
	float getAverageTemperature(Sensor sensor, Date from, Date to);
	
	Temperature getMaxTemperature(Sensor sensor, Date from, Date to);
	
	Temperature getMinTemperature(Sensor sensor, Date from, Date to);
	
}
