package miolnet.modules.heating.model;

import java.io.Serializable;
import java.time.LocalTime;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.Max;
import javax.validation.constraints.Min;

@Entity
@NamedQuery(name = "findAllDayPeriods", query = "select a from DayPeriod a")
public class DayPeriod implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	@GeneratedValue
	private int id;
	
	private LocalTime startTime;
	
	private LocalTime endTime;
	
	@Max(value=40)
	@Min(value=0)
	private float temperature;
	
	public DayPeriod() {
	}
	
	public DayPeriod(LocalTime start, LocalTime end, float temp) {
		startTime = start;
		endTime = end;
		temperature = temp;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public LocalTime getStartTime() {
		return startTime;
	}

	public void setStartTime(LocalTime startTime) {
		this.startTime = startTime;
	}

	public LocalTime getEndTime() {
		return endTime;
	}

	public void setEndTime(LocalTime endTime) {
		this.endTime = endTime;
	}

	public float getTemperature() {
		return temperature;
	}

	public void setTemperature(float temperature) {
		this.temperature = temperature;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		DayPeriod other = (DayPeriod) obj;
		return id == other.id;
	}

	@Override
	public String toString() {
		return "DayPeriod [startTime=" + startTime + ", endTime=" + endTime + ", temperature=" + temperature + "]";
	}
	
}
