package miolnet.modules.heating.model;

import java.io.Serializable;

public class SensorData implements Serializable {
	
	private static final long serialVersionUID = 1L;
	
	private Type sensorType;
	private float value;
	private int priority;
	
	public enum Type {
		INDOOR, OUTDOOR
	}
	
	public SensorData() {
	}
	
	public SensorData(Type type, int priority, float value) {
		this.sensorType = type;
		this.priority = priority;
		this.value = value;
	}

	public Type getSensorType() {
		return sensorType;
	}

	public void setSensorType(Type sensorType) {
		this.sensorType = sensorType;
	}

	public float getValue() {
		return value;
	}

	public void setValue(float value) {
		this.value = value;
	}

	public int getPriority() {
		return priority;
	}

	public void setPriority(int priority) {
		this.priority = priority;
	}

	@Override
	public String toString() {
		return "SensorData [sensorType=" + sensorType + ", value=" + value + ", priority=" + priority + "]";
	}
	
}
