package miolnet.modules.heating.services;

import java.time.LocalTime;
import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;

import miolnet.modules.heating.model.DayPeriod;

/**
 * Session Bean implementation class DayPeriodService
 */
@Stateless
public class DayPeriodService implements DayPeriodServiceLocal {

	@PersistenceContext(unitName = "miolnet.db")
	private EntityManager em;
	
    /**
     * Default constructor. 
     */
    public DayPeriodService() {
    }

	@Override
	public DayPeriod createDayPeriod(final DayPeriod dayPeriod) {
		//TODO: add check
		em.persist(dayPeriod);
		return dayPeriod;
	}

	@Override
	public DayPeriod createDayPeriod(final LocalTime start, final LocalTime end, float temp) {
		//TODO: add check
		final DayPeriod dayPeriod = new DayPeriod(start, end, temp);
		em.persist(dayPeriod);
		return dayPeriod;
	}

	@Override
	public DayPeriod updateDayPeriod(final DayPeriod dayPeriod) {
		//TODO: add echck
		return em.merge(dayPeriod);
	}

	@Override
	public DayPeriod removeDayPeriod(final DayPeriod dayPeriod) {
		//TODO: add check
		final DayPeriod dp = em.find(DayPeriod.class, dayPeriod.getId());
		em.remove(dp);
		return dp;
	}

	@Override
	public List<DayPeriod> getAll() {
		final TypedQuery<DayPeriod> query = em.createNamedQuery("findAllDayPeriods", DayPeriod.class);
		return query.getResultList();
	}

	@Override
	public DayPeriod getById(int id) {
		return em.find(DayPeriod.class, id);
	}

	@Override
	public DayPeriod getByTime(final LocalTime time) {
		final List<DayPeriod> dayPeriods = getAll();
		for (final DayPeriod dp : dayPeriods) {
			if (time.isAfter(dp.getStartTime()) && time.isBefore(dp.getEndTime())) {
				return dp;
			}
		}
		return null;
	}

}
