package miolnet.modules.heating.services;

import java.time.LocalTime;
import java.util.List;

import javax.ejb.Local;

import miolnet.modules.heating.model.DayPeriod;

@Local
public interface DayPeriodServiceLocal {

	/**
	 * 
	 * @param dayPeriod
	 * @return
	 */
	DayPeriod createDayPeriod(DayPeriod dayPeriod);
	
	/**
	 * 
	 * @param start
	 * @param end
	 * @param temp
	 * @return
	 */
	DayPeriod createDayPeriod(LocalTime start, LocalTime end, float temp);
	
	/**
	 * 
	 * @param dayPeriod
	 * @return
	 */
	DayPeriod updateDayPeriod(DayPeriod dayPeriod);
	
	/**
	 * 
	 * @param dayPeriod
	 * @return
	 */
	DayPeriod removeDayPeriod(DayPeriod dayPeriod);
	
	/**
	 * 
	 * @return
	 */
	List<DayPeriod> getAll();
	
	/**
	 * 
	 * @param id
	 * @return
	 */
	DayPeriod getById(int id);
	
	/**
	 * 
	 * @param time
	 * @return
	 */
	DayPeriod getByTime(LocalTime time);
	
}
