package miolnet.modules.heating.services;

import java.text.ParseException;
import java.time.LocalDate;
import java.util.List;
import java.util.Map;

import javax.ejb.Local;

import miolnet.model.ModuleSensor;
import miolnet.model.Record;
import miolnet.modules.heating.model.SensorData;

@Local
public interface HeatingControlServiceLocal {
	
	String getMTag();
	
	boolean isCurrentlyHeatingOn();
	
	int calculateHeatingDuration();
	
	float getCurrentTemp();
	
	Map<String, String> getSettings();

	float getTempFromRecordValue(String value) throws ParseException;
	
	SensorData.Type getSensorType(String usc);
	
	boolean heatNow(int duration);
	
	void saveSettings(boolean heatingEnabled, float difference, float outdoorTempLimit);
	
	List<ModuleSensor> getSensors();
	
	List<Record> getHistory(int numOfRecords);
	
	boolean isHeatNowOverlapping();
	
	void expireHeatNow();
	
	boolean isHeatNowOn();
	
	int calculateOverallDayHeatingTime(LocalDate day);
	
}
