package miolnet.modules.heating.services;

import java.time.LocalTime;
import java.util.List;
import java.util.Map;

import javax.ejb.Remote;

import miolnet.modules.heating.model.DayPeriod;
import miolnet.modules.heating.model.SensorData;

@Remote
public interface HeatingDataServiceRemote {

	/**
	 * Settings keys in map: heatingHysteresisDifference, heatingEnabled and heatingHeatNow
	 * 
	 * @return Heating settings in HashMap. (NotNull)
	 */
	Map<String, String> getSettings();
	
	List<SensorData> getData();
	
	LocalTime getServerTime();
	
	List<DayPeriod> getDayPeriods();
	
	void sendHeatingState(boolean isHeatingOn);
	
	void sendHeatingState(boolean isHeatingOn, float temp);
	
	void sendCalculatedAvgTemp(float temp);
	
}
