package miolnet.client.thermoregulator;

public interface Sensor {

	boolean isPresent();
	float getValue() throws ValueReadingException;
	
	class ValueReadingException extends Exception {

		private static final long serialVersionUID = 1L;
		private static final String MSG = "There have been error during reading value from Sensor with USC %s, full output: %s";
		
		public ValueReadingException(final String usc, final String fullOutput) {
			super(String.format(MSG, usc, fullOutput));
		}
		
		public ValueReadingException(final String usc, final String fullOutput, final Throwable cause) {
			super(String.format(MSG, usc, fullOutput), cause);
		}
		
	}
	
}
