
$(document).ready(function(){

	$(".chart").each(function(i, obj) {
		
	// === Make chart === //
    var plot = $.plot(obj,
           [ { data: JSON.parse(obj.dataset.points), color: "#ee7951"} ], {
               series: {
                   lines: { show: true },
                   points: { show: true }
               },
               xaxis: {
            	   mode: "time",
            	   timezone: "browser"
               },
               yaxis: {
            	   tickFormatter: function(num, obj){return num+"°C"}
               },
               grid: { hoverable: true, clickable: true }
		   });
    
	// === Point hover in chart === //
    var previousPoint = null;
    $(obj).bind("plothover", function (event, pos, item) {
		
        if (item) {
            if (previousPoint != item.dataIndex) {
                previousPoint = item.dataIndex;
                
                $('#tooltip').fadeOut(200,function(){
					$(this).remove();
				});
                var x = item.datapoint[0].toFixed(2),
					y = item.datapoint[1].toFixed(2);
                var d = new Date(parseInt(x));
                var datetime = d.getDate() + "." + (d.getMonth()+1) + "." + d.getFullYear() + " " + addZero(d.getHours()) + 
                	":" + addZero(d.getMinutes()) + ":" + addZero(d.getSeconds());
                maruti.flot_tooltip(item.pageX, item.pageY, datetime + " = " + y + "°C");
            }
            
        } else {
			$('#tooltip').fadeOut(200,function(){
					$(this).remove();
				});
            previousPoint = null;           
        }   
    });
    
	});
});
	
maruti = {
		// === Tooltip for flot charts === //
		flot_tooltip: function(x, y, contents) {
			
			$('<div id="tooltip">' + contents + '</div>').css( {
				top: y + 5,
				left: x + 5
			}).appendTo("body").fadeIn(200);
		}
}

function addZero(i) {
	if( i < 10) {
		i = "0" + i;
	}
	
	return i;
}
