package miolnet.web.controllers;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.RequestScoped;

import miolnet.model.Sensor;
import miolnet.model.Setting;
import miolnet.services.SensorServiceLocal;
import miolnet.services.SettingServiceLocal;

@ManagedBean
@RequestScoped
public class DashboardController {
	
	@EJB
	private SensorServiceLocal sensorService;
	
	@EJB
	private SettingServiceLocal settingsService;
	
	@ManagedProperty("#{settingsController}")
	private SettingsController settingsController;

	private List<Sensor> selectedSensors;
	private List<Sensor> selectedChartSensors;

	@PostConstruct
	public void init() {
		List<Setting> settedDashboardSensors = settingsService.getSettingsByName("dashboardSensor");
		List<Setting> settedDashboardChartSensors = settingsService.getSettingsByName("dashboardChartSensor");
		
		selectedSensors = settingsController.getSelectedSensorsFromSettings(settedDashboardSensors);
		if (selectedSensors.isEmpty()) {
			selectedSensors = sensorService.getAll();
			if (selectedSensors == null) {
				selectedSensors = new ArrayList<>();
			}
		}
		selectedChartSensors = settingsController.getSelectedSensorsFromSettings(settedDashboardChartSensors);
	}

	public List<Sensor> getSelectedSensors() {
		return selectedSensors;
	}

	public List<Sensor> getSelectedChartSensors() {
		return selectedChartSensors;
	}

	public void setSettingsController(SettingsController settingsController) {
		this.settingsController = settingsController;
	}
	
}
