package miolnet.web.controllers;

import java.util.Map;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import miolnet.guconnectivity.Protocol;
import miolnet.model.GatheringUnit;
import miolnet.model.LoginDetails;
import miolnet.services.GatheringUnitServiceLocal;

@ManagedBean
@RequestScoped
public class GatheringunitController {
	
	@EJB
	private GatheringUnitServiceLocal gUnitService;
	
	private GatheringUnit gunit;
	
	@PostConstruct
	public void init() {
		HttpServletRequest request = (HttpServletRequest) FacesContext.getCurrentInstance().getExternalContext().getRequest();
		String idParam = request.getParameter("id");
		
		if (idParam != null) {
			try {
				int id = Integer.parseInt(idParam);
				final GatheringUnit gu = gUnitService.getById(id);
				if (gu != null) {
					gunit = gu;
					return;
				}
			} catch(NumberFormatException e) {
			}
		}
		
		gunit = new GatheringUnit();
		gunit.setLoginDetails(new LoginDetails());
	}
	
	public String add() {
		gUnitService.createGatheringUnit(gunit);
		return "gatheringunits.jsf?faces-redirect=true";
	}
	
	public String update() {
		gUnitService.updateGatheringUnit(gunit);
		return "showgatheringunit.jsf?id="+gunit.getId()+"&faces-redirect=true";
	}
	
	public String remove(int id) {
		final GatheringUnit gunit = gUnitService.getById(id);
		if (gunit != null) {
			gUnitService.removeGatheringUnit(gunit);
			return "gatheringunits.jsf?faces-redirect=true";
		} 
		else {
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage("Sběrná jednotka s id "+id+" neexistuje!"));
			return null;
		}
	}
	
	public String remove() {
		String idParam = ((Map<String, String>)FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap()).get("id");
		if (idParam != null) {
			try {
				int id = Integer.parseInt(idParam);
				final GatheringUnit gu = gUnitService.getById(id);
				if (gu != null) {
					gUnitService.removeGatheringUnit(gunit);
				}
			} catch(NumberFormatException e) {
			}
		}
		return "gatheringunits.jsf?faces-redirect=true";
	}
	
	public Protocol[] getProtocols() {
		return Protocol.values();
	}

	public GatheringUnit getGunit() {
		return gunit;
	}

	public void setGunit(GatheringUnit gunit) {
		this.gunit = gunit;
	}

}
