package miolnet.web.controllers;

import java.util.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;

import miolnet.model.Sensor;
import miolnet.model.Temperature;
import miolnet.services.TemperatureServiceLocal;

@ManagedBean
@RequestScoped
public class GraphController {

	@EJB
	private TemperatureServiceLocal tempService;
	
	private String interval;
	private Date from;
	private Date to;
	
	@PostConstruct
	public void init() {
		interval = "1";
		to = new Date();
		from = new Date(to.getTime() - 86400000);
	}
	
	public List<Temperature> getData(final Sensor sensor) {
		switch (interval) {
			case "2":
				return tempService.getWeekTemperatures(sensor);
			case "3":
				return tempService.getMonthTemperatures(sensor);
			case "4":
				return tempService.getYearTemperatures(sensor);
			case "5":
				return tempService.getCustomIntervalTemperatures(sensor, from, to);
		}
		return tempService.getDayTemperatures(sensor);
	}
	
	public void display() {
		
	}

	public String getInterval() {
		return interval;
	}

	public void setInterval(String interval) {
		this.interval = interval;
	}

	public Date getFrom() {
		return from;
	}

	public void setFrom(Date from) {
		this.from = from;
	}

	public Date getTo() {
		return to;
	}

	public void setTo(Date to) {
		this.to = to;
	}
	
}
