package miolnet.web.controllers;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

import miolnet.model.Module;
import miolnet.services.ModuleServiceLocal;

@ManagedBean
@RequestScoped
public class MainController {
	
	public static final String version = "0.4.1";
	
	public static final String datetimeFormat = "dd.MM.yyyy HH:mm:ss";
	
	@EJB
	private ModuleServiceLocal moduleService;
	
	private List<Module> modules;
	
	@PostConstruct
	public void init() {
		modules = moduleService.getAll();
		final Iterator<Module> it = modules.iterator();
		Module m;
		while (it.hasNext()) {
			m = it.next();
			if (!m.isEnabled()) {
				it.remove();
			}
		}
	}
	
	public String logoutUser() {
		FacesContext.getCurrentInstance().getExternalContext().invalidateSession();
		return "index.jsf?faces-redirect=true";
	}
	
	public void redirectToIndexIfLoggedIn() throws IOException {
		ExternalContext ec = FacesContext.getCurrentInstance().getExternalContext();
		if (ec.getRemoteUser() != null) {
			ec.redirect(ec.getRequestContextPath() + "/index.jsf");
		}
	}

	public String forwardToSensors() {
		return "sensors.jsf";
	}
	
	public List<Module> getModules() {
		return modules;
	}

	public void setModules(List<Module> modules) {
		this.modules = modules;
	}

	public String getVersion() {
		return version;
	}

	public String getDatetimeFormat() {
		return datetimeFormat;
	}
	
}
