package miolnet.web.controllers;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;

import miolnet.model.Sensor;
import miolnet.services.SensorServiceLocal;
import miolnet.services.TemperatureServiceLocal;

@ManagedBean
@RequestScoped
public class SensorsController {

	@EJB
	private SensorServiceLocal sensorService;
	
	private List<Sensor> sensors;
	
	@PostConstruct
	public void init() {
		sensors = sensorService.getAll();
		if (sensors == null) {
			sensors = new ArrayList<>();
		}
	}

	public List<Sensor> getSensors() {
		return sensors;
	}

	public void setSensors(List<Sensor> sensors) {
		this.sensors = sensors;
	}

}
