package miolnet.web.controllers.modheating;

import java.time.LocalTime;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import miolnet.modules.heating.model.DayPeriod;
import miolnet.modules.heating.services.DayPeriodServiceLocal;

@ManagedBean
@RequestScoped
public class DayPeriodController {
	
	@EJB
	private DayPeriodServiceLocal dayPeriodService;
	
	private DayPeriod dp;

	@PostConstruct
	public void init() {
		HttpServletRequest request = (HttpServletRequest) FacesContext.getCurrentInstance().getExternalContext().getRequest();
		String idParam = request.getParameter("id");
		
		if (idParam != null) {
			try {
				int id = Integer.parseInt(idParam);
				final DayPeriod dayperiod = dayPeriodService.getById(id);
				if (dayperiod != null) {
					dp = dayperiod;
					return;
				}
			} catch(NumberFormatException e) {
			}
		}
		
		dp = new DayPeriod();
		dp.setTemperature(22);
		dp.setStartTime(LocalTime.MIN);
		dp.setEndTime(LocalTime.MAX);
	}
	
	public String add() {
		dayPeriodService.createDayPeriod(dp.getStartTime(), dp.getEndTime(), dp.getTemperature());
		return "heating.jsf?faces-redirect=true";
	}
	
	public String update() {
		dayPeriodService.updateDayPeriod(dp);
		return "heating.jsf?faces-redirect=true";
	}
	
	public String remove(int id) {
		final DayPeriod dayperiod = dayPeriodService.getById(id);
		if (dayperiod != null) {
			dayPeriodService.removeDayPeriod(dayperiod);
			return "heating.jsf?faces-redirect=true";
		}
		else {
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage("Denní doba s id "+id+" neexistuje!"));
			return null;
		}
	}

	public DayPeriod getDp() {
		return dp;
	}

	public void setDp(DayPeriod dp) {
		this.dp = dp;
	}
	
}
