package miolnet.web.converters;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

import miolnet.model.Role;
import miolnet.services.RoleServiceLocal;

@ManagedBean
public class RoleConverter implements Converter {
	
	@EJB
	private RoleServiceLocal roleService;

	@Override
	public Object getAsObject(FacesContext arg0, UIComponent arg1, String value) {
		if (value == null || value.isEmpty()) {
			throw new ConverterException(new FacesMessage("Empty ID!"));
        }

        try {
        	final Role r = roleService.getById(Integer.valueOf(value));
        	if (r == null) {
        		throw new ConverterException(new FacesMessage(String.format("Role with ID %s doesn't exist!", value)));
        	}
            return r;
        } catch (NumberFormatException e) {
            throw new ConverterException(new FacesMessage(String.format("%s is not a valid Role ID!", value)), e);
        }
	}

	@Override
	public String getAsString(FacesContext arg0, UIComponent arg1, Object value) {
		if (value == null) {
            return "";
        }

        if (value instanceof Role) {
            return String.valueOf(((Role) value).getId());
        } else {
            throw new ConverterException(new FacesMessage(String.format("%s is not a valid Role!", value)));
        }
	}

}
