package miolnet.web.converters;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

import miolnet.model.Sensor;
import miolnet.services.SensorServiceLocal;

@ManagedBean
public class SensorConverter implements Converter {

	@EJB
	private SensorServiceLocal sensorService;
	
	@Override
	public Object getAsObject(FacesContext arg0, UIComponent arg1, String value) {
		if (value == null || value.isEmpty()) {
			throw new ConverterException(new FacesMessage("Empty ID!"));
        }

        try {
        	final Sensor s = sensorService.getById(Integer.valueOf(value));
        	if (s == null) {
        		throw new ConverterException(new FacesMessage(String.format("Sensor with ID %s doesn't exist!", value)));
        	}
            return s;
        } catch (NumberFormatException e) {
            throw new ConverterException(new FacesMessage(String.format("%s is not a valid Sensor ID!", value)), e);
        }
	}

	@Override
	public String getAsString(FacesContext arg0, UIComponent arg1, Object value) {
		if (value == null) {
            return "";
        }

        if (value instanceof Sensor) {
            return String.valueOf(((Sensor) value).getId());
        } else {
            throw new ConverterException(new FacesMessage(String.format("%s is not a valid Sensor!", value)));
        }
	}

}
