package miolnet.web.converters;

import java.time.LocalTime;
import java.time.format.DateTimeFormatterBuilder;
import java.time.format.DateTimeParseException;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;

@FacesConverter("timeConverter")
public class TimeConverter implements Converter {

	@Override
	public Object getAsObject(FacesContext arg0, UIComponent arg1, String value) {
		try {
			if ("23:59".equals(value)) {
				return LocalTime.MAX;
			}
			return LocalTime.parse(value, new DateTimeFormatterBuilder().appendPattern("HH:mm").toFormatter());
		} catch(DateTimeParseException e) {
		}
		try {
			return LocalTime.parse(value, new DateTimeFormatterBuilder().appendPattern("H:mm").toFormatter());
		} catch(DateTimeParseException e) {
		}
		try {
			return LocalTime.parse(value, new DateTimeFormatterBuilder().appendPattern("HH").toFormatter());
		} catch(DateTimeParseException e) {
		}
		return LocalTime.parse(value, new DateTimeFormatterBuilder().appendPattern("H").toFormatter());
	}

	@Override
	public String getAsString(FacesContext arg0, UIComponent arg1, Object value) {
		if (value != null && value instanceof LocalTime) {
			return ((LocalTime)value).format(new DateTimeFormatterBuilder().appendPattern("HH:mm").toFormatter());
		}
		return "00:00";
	}

}
