/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.0 		*/
/*  Created On : 18-11-2017 13:37:06 				*/
/*  DBMS       : MySql 						*/
/* ---------------------------------------------------- */

SET FOREIGN_KEY_CHECKS=0 
;

/* Drop Tables */

DROP TABLE IF EXISTS `Gatheringunits` CASCADE
;

DROP TABLE IF EXISTS `Gathers` CASCADE
;

DROP TABLE IF EXISTS `Logindetails` CASCADE
;

DROP TABLE IF EXISTS `Modules` CASCADE
;

DROP TABLE IF EXISTS `Modulesensors` CASCADE
;

DROP TABLE IF EXISTS `Records` CASCADE
;

DROP TABLE IF EXISTS `Roles` CASCADE
;

DROP TABLE IF EXISTS `Sensors` CASCADE
;

DROP TABLE IF EXISTS `Settings` CASCADE
;

DROP TABLE IF EXISTS `Temperatures` CASCADE
;

DROP TABLE IF EXISTS `Users` CASCADE
;

/* Create Tables */

CREATE TABLE `Gatheringunits`
(
	`Available` BOOL NULL,
	`Description` TEXT NULL,
	`Ip` VARCHAR(39) NOT NULL,
	`LastGatherTime` DATETIME NULL,
	`Name` VARCHAR(60) NOT NULL,
	`GatheringunitID` INT NOT NULL AUTO_INCREMENT,
	`LogindetailsID` INT NOT NULL,
	CONSTRAINT `PK_Gatheringunit` PRIMARY KEY (`GatheringunitID` ASC)
)

;

CREATE TABLE `Gathers`
(
	`Gathertime` DATETIME NOT NULL,
	`GatherID` INT NOT NULL AUTO_INCREMENT,
	CONSTRAINT `PK_Gather` PRIMARY KEY (`GatherID` ASC)
)

;

CREATE TABLE `Logindetails`
(
	`Password` VARCHAR(32) NOT NULL,
	`Protocol` VARCHAR(5) NOT NULL,
	`Username` VARCHAR(40) NOT NULL,
	`LogindetailsID` INT NOT NULL AUTO_INCREMENT,
	CONSTRAINT `PK_Logindetails` PRIMARY KEY (`LogindetailsID` ASC)
)

;

CREATE TABLE `Modules`
(
	`Author` VARCHAR(40) NULL,
	`Description` TEXT NULL,
	`Enabled` BOOL NULL DEFAULT true,
	`Name` VARCHAR(40) NOT NULL,
	`Tag` VARCHAR(20) NOT NULL,
	`Version` VARCHAR(12) NULL,
	`ModuleID` INT NOT NULL AUTO_INCREMENT,
	CONSTRAINT `PK_Module` PRIMARY KEY (`ModuleID` ASC)
)

;

CREATE TABLE `Modulesensors`
(
	`Priority` INT NULL,
	`ModulesensorID` INT NOT NULL AUTO_INCREMENT,
	`ModuleID` INT NOT NULL,
	`SensorID` INT NOT NULL,
	CONSTRAINT `PK_Modulesensor` PRIMARY KEY (`ModulesensorID` ASC)
)

;

CREATE TABLE `Records`
(
	`Recordtime` DATETIME NOT NULL,
	`Status` BOOL NULL,
	`Value` VARCHAR(128) NOT NULL,
	`RecordID` INT NOT NULL AUTO_INCREMENT,
	`ModuleID` INT NULL,
	`UserID` INT NULL,
	CONSTRAINT `PK_Record` PRIMARY KEY (`RecordID` ASC)
)

;

CREATE TABLE `Roles`
(
	`Name` VARCHAR(20) NOT NULL,
	`RoleID` INT NOT NULL AUTO_INCREMENT,
	CONSTRAINT `PK_Role` PRIMARY KEY (`RoleID` ASC)
)

;

CREATE TABLE `Sensors`
(
	`Available` BOOL NULL,
	`Calibration` FLOAT(4,3) NULL,
	`GatherInterval` INT NULL,
	`Installed` DATETIME NOT NULL,
	`LastGatherTime` DATETIME NULL,
	`Name` VARCHAR(60) NOT NULL,
	`Notes` TEXT NULL,
	`Usc` CHAR(15) NOT NULL,
	`SensorID` INT NOT NULL AUTO_INCREMENT,
	`GatheringunitID` INT NOT NULL,
	CONSTRAINT `PK_Sensor` PRIMARY KEY (`SensorID` ASC)
)

;

CREATE TABLE `Settings`
(
	`Name` VARCHAR(32) NOT NULL,
	`Value` VARCHAR(128) NULL,
	`SettingID` INT NOT NULL AUTO_INCREMENT,
	`ModuleID` INT NULL,
	CONSTRAINT `PK_Setting` PRIMARY KEY (`SettingID` ASC)
)

;

CREATE TABLE `Temperatures`
(
	`Temp` FLOAT(6,3) NOT NULL,
	`TemperatureID` INT NOT NULL AUTO_INCREMENT,
	`GatherID` INT NOT NULL,
	`SensorID` INT NOT NULL,
	CONSTRAINT `PK_Temperature` PRIMARY KEY (`TemperatureID` ASC)
)

;

CREATE TABLE `Users`
(
	`Password` CHAR(64) NOT NULL,
	`Username` VARCHAR(40) NOT NULL,
	`UserID` INT NOT NULL AUTO_INCREMENT,
	`RoleID` INT NULL,
	CONSTRAINT `PK_User` PRIMARY KEY (`UserID` ASC)
)

;

/* Create Foreign Key Constraints */

ALTER TABLE `Gatheringunits` 
 ADD CONSTRAINT `LogindetailsID`
	FOREIGN KEY (`LogindetailsID`) REFERENCES `Logindetails` (`LogindetailsID`) ON DELETE Restrict ON UPDATE Restrict
;

ALTER TABLE `Modulesensors` 
 ADD CONSTRAINT `FK_ModuleSensor_Module`
	FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE `Modulesensors` 
 ADD CONSTRAINT `FK_ModuleSensor_Sensor`
	FOREIGN KEY (`SensorID`) REFERENCES `Sensors` (`SensorID`) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE `Records` 
 ADD CONSTRAINT `FK_Record_Module`
	FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE `Records` 
 ADD CONSTRAINT `FK_Record_User`
	FOREIGN KEY (`UserID`) REFERENCES `Users` (`UserID`) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE `Sensors` 
 ADD CONSTRAINT `FK_Sensor_Gatheringunit`
	FOREIGN KEY (`GatheringunitID`) REFERENCES `Gatheringunits` (`GatheringunitID`) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE `Settings` 
 ADD CONSTRAINT `FK_Setting_Module`
	FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE `Temperatures` 
 ADD CONSTRAINT `FK_Temperature_Gather`
	FOREIGN KEY (`GatherID`) REFERENCES `Gathers` (`GatherID`) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE `Temperatures` 
 ADD CONSTRAINT `FK_Temperature_Sensor`
	FOREIGN KEY (`SensorID`) REFERENCES `Sensors` (`SensorID`) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE `Users` 
 ADD CONSTRAINT `FK_User_Role`
	FOREIGN KEY (`RoleID`) REFERENCES `Roles` (`RoleID`) ON DELETE No Action ON UPDATE No Action
;

SET FOREIGN_KEY_CHECKS=1 
;

CREATE VIEW UsersRoles AS SELECT u.Username as 'Username', u.Password as 'Password', r.Name as 'Role' FROM Users u
LEFT JOIN Roles r ON u.RoleID = r.RoleID;

INSERT INTO `Roles` (`Name`) VALUES ('admin');
INSERT INTO `Roles` (`Name`) VALUES ('user');

/* Username: admin Password: admin */
INSERT INTO `Users` (`Username`, `Password`, `RoleID`) VALUES ('admin', '8c6976e5b5410415bde908bd4dee15dfb167a9c873fc4bb8a81f6f2ab448a918', 1);

